/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package es.uca.takuan.netbeans.wizard;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.swing.JFileChooser;
import javax.swing.JPanel;

import org.openide.util.Exceptions;
import org.openide.util.NbBundle;

import es.uca.takuan.client.Bpel;

public final class BpelVisualPanel5 extends JPanel {

    private Bpel bpel;

    /** Creates new form BpelVisualPanel5 */
    public BpelVisualPanel5() {
        initComponents();
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(BpelVisualPanel5.class, "WIZARD_SAVE_TITLE");
    }

    /** Set the BPEL we are working with
     * @param b The BPEL instance
     */
    public void setBpel(Bpel b) {
        bpel = b;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblDescription = new javax.swing.JLabel();
        cmdCopy = new javax.swing.JButton();

        lblDescription.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(lblDescription, org.openide.util.NbBundle.getMessage(BpelVisualPanel5.class, "WIZARD_SAVE_DESCRIPTION")); // NOI18N
        lblDescription.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        cmdCopy.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(cmdCopy, org.openide.util.NbBundle.getMessage(BpelVisualPanel5.class, "WIZARD_SAVE_COPY")); // NOI18N
        cmdCopy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveCopyActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lblDescription, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .add(cmdCopy))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(lblDescription, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 49, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 203, Short.MAX_VALUE)
                .add(cmdCopy)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    /** This event saves a copy of the modified BPEL
     * @param evt
     */
    private void saveCopyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveCopyActionPerformed
        JFileChooser saveDialog = new JFileChooser();

        saveDialog.setMultiSelectionEnabled(false);

        if(saveDialog.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
        {
            try {
                OutputStream output = null;
                InputStream input = bpel.getStream();
                byte buffer[] = new byte[256];

                output = new FileOutputStream(saveDialog.getSelectedFile());

                int n;
                while((n = input.read(buffer)) > 0) {
                    output.write(buffer, 0, n);
                }

            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }//GEN-LAST:event_saveCopyActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdCopy;
    private javax.swing.JLabel lblDescription;
    // End of variables declaration//GEN-END:variables
}

